<?php
/*******************************************************************************
 Exemple of the use of the snmp class
 each object function return the result, the error code, the error message
   (ex: when the object is $obj will return $this->errormsg,$this->result,$this->retcode)

 
 PS: if you are using snmp_networkclass you don't need to know this !!!!! 
    (it is the strongness of the classes)
*******************************************************************************/

/* ---------------------------------------------------------------------- */
//  VARIABLES TO changes and have for your plugins
/* ---------------------------------------------------------------------- */
$sharednetworkclasspath= "." ; // path_to_the_sharednetworkclass
/* ---------------------------------------------------------------------- */
include($sharednetworkclasspath."/snmpclass.php");


/* ---------------------------------------------------------------------- */
/* BEGIN of the EXAMPLE */
/* ---------------------------------------------------------------------- */

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

someExamplesToExecute();
exit;


function someExamplesToExecute() {
  // for CACTI user here commented
  // $retries = read_config_option("snmp_retries");
  // if ($retries == "") $retries = 3;
  $retries = 3;
  
  /* initialize the value of my device to test */
  $host = "10.249.46.6"; 
  $community="public";     // your community string or "" for default="public"
  $version = "1";          // your snmp version "1" or "2" or "2c" or "3" or "" for default="1"
  $user = "";              // your snmp user for version 3
  $password ="";           // your snmp password for version 3
  $port = "";              // your snmp port or "" for default="161"
  $timeout = 800;          // your snmp timeout in milliseconds or "" for default="500"
  $method=SNMP_METHOD_PHP; // SNMP_METHOD_PHP (for pure PHP) or SNMP_METHOD_BINARY (for NET_SNMP or something else) // this name are for compatibility with cacti
                           // for CACTI $method= snmp_get_method($version);
  $sess = array($host,$version,$community,$user,$password,$port,$timeout,$retries,$method);
  
  /* initalise the object */
  $obdevice=new snmpclass;
  $obdevice->Init($sess);
print "param hostname:".$obdevice->param["hostname"]."\n";
print "param version:".$obdevice->param["version"]."\n";
print "param community:".$obdevice->param["string"]."\n";
print "param user:".$obdevice->param["user"]."\n";
print "param password:".$obdevice->param["password"]."\n";
print "param port:".$obdevice->param["port"]."\n";
print "param timeout:".$obdevice->param["timeout"]."\n";
print "param retries:".$obdevice->param["retries"]."\n";
print "param method:".$obdevice->param["method"]."\n";
print "init:".(($obdevice->ini)?"yes":"no")."\n";
print "init error:".(($obdevice->retcode)?"yes":"no"."->".$obdevice->errormsg)."\n";
  // You can also set the path to the binary or change the default NET_SNMP filenames with
  // $obdevice->Init($sess,$path_to_snmp_binary,$other_get_filename,$other_getnext_filename,$other_walk_filename,$other_set_filename,$snmpbinversion);
  // default NET_SNMPNAME are "snmpget", "snmpgetnext", "snmpwalk", "snmpset" (in windows with .exe at the end
  // for that reason you normally need only to give the NET_SNMP path if you want to use the binaries
  // you can also give the type of binaries $snmpbinversion<-SNMP_METHOD_NET or SNMP_METHOD_UCD default is SNMP_METHOD_NET
  // in CACTI you can set with $snmpbinversion=read_config_option("snmp_version")

  // to get the sysContact
/*
print "Same with NET_SNMP\n";
$method=SNMP_METHOD_BINARY;
$obdevice->snmpmethod($method,"D:/Programme/NET-SNMP/usr/bin"); //,"","","","","");
*/
  $oid = ".1.3.6.1.2.1.1.4.0"; // mib or OID to test here "sysContact". You can use also the mibname (depending of your php or NET_SNMP)
  $obdevice->get($oid);
  if ($obdevice->retcode) print "GET($oid)-> result=".$obdevice->result." \n";
  else print "GET($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  $obdevice->getnext($oid);
  if ($obdevice->retcode) print "GETNEXT($oid)-> result=".$obdevice->result." \n";
  else print "GETNEXT($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  // change the sysContact
  $obdevice->setsnmpcommunity("private");
  $obdevice->set($oid,"s","My contact");
  if ($obdevice->retcode) print "SET($oid)-> result=".$obdevice->result." \n";
  else print "SET($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  $obdevice->setsnmpcommunity("public");
  $obdevice->get($oid);
  if ($obdevice->retcode) print "GET($oid)-> result=".$obdevice->result." \n";
  else print "GET($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  /* WALK */
  $oid = ".1.3.6.1.2.1.4";
/*
  $obdevice->walk($oid);
  if ($obdevice->retcode) print "WALK($oid)-> result=".print_r($obdevice->result,true)." \n";
  else print "WALK($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
*/
  
  //Same with NET_SNMP && changing the method with the same session
/*
  print "Same with NET_SNMP\n";
  $method=SNMP_METHOD_BINARY;
  $obdevice->snmpmethod($method,"D:/Programme/NET-SNMP/usr/bin"); //,"","","","","");
  $oid = ".1.3.6.1.2.1.1.4.0"; // mib or OID to test here "sysContact". You can use also the mibname (depending of your php or NET_SNMP)
  $obdevice->get($oid);
  if ($obdevice->retcode) print "GET($oid)-> result=".$obdevice->result." \n";
  else print "GET($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
  $oid = ".1.3.6.1.2.1.4";
  $obdevice->walk($oid);
  if ($obdevice->retcode) print "WALK($oid)-> result=".print_r($obdevice->result,true)." \n";
  else print "WALK($oid)-> Error=".$obdevice->errormsg." result=".$obdevice->result." \n";
*/

  $obdevice->close();
}

?>