<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************
    Author ......... Jean-Michel Pepin classes plugin for network devices (PEPJ in forum.cacti.net & http://cactiusers.org/forums/)
    Modified ....... .
    Program ........ class definition for cabletron network devices in PHP for Cacti or PHP software

    congratulation: Thanks to all the developpers of cacti cacti http://www.cacti.net.
//references CTRON-DOWNLOAD-MIB  
*******************************************************************************/
/* define the OID of the vendor */
$toidvendor['cabletron']    = '.1.3.6.1.4.1.52';
$toidtovendor['.1.3.6.1.4.1.52'] = 'cabletron';

class cabletronnetworkclass
{
   function vendorname($FunctionName)
   {
        return "cabletron";       
   }
   function showclass()
   {
        return "this is a cabletron class";       
   }
   function priv($obj,$FunctionName,$param="")
   {
   	$fct = "cabletron".$FunctionName;
   	if (function_exists($fct)) $ret = ($param=="") ? $fct($obj) : $fct($obj,$param);
       	else {
       	  $ret=0;
          $obj->result= array();
          $obj->errormsg = "Error: Function does not exist.";
          $obj->retcode = $ret;
       	}
        return $ret;
   }
   function tftp($obj)
   {
	cabletronTFTPtransfer($obj);
   }
   /* return if the device is a host */
   function DeviceIsHost($objdevice,$init=false) {
     global $networkclass_isdebug,$networkclass_islog;
     // cabletron always false

     // the two following value could help you to find it
     // $obj->description();  // to be sure description has been ask at least one time
     // $description = $obj->result; or $description = $obj->description;
     // $oiddevice = $objdevice->oiddevice;
     //force debug $objdevice->setdebug(true,true);
     // if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG DeviceIsHost ->".print_r($valmib,true)."\n");
     if ($init) {
        $objdevice->ishost =false;
     }
     $result= $objdevice->ishost;
     return $result;
   }
}

/* return the type of the device (used only for the function in this class in case of a specific behaviour)
*/
function cabletronChecktypdevice($obj) {
   $description  = $obj->description;
   $oiddevice  = $obj->oiddevice;
   $typdevice = "unknow";
   switch (true) {
	case (substr_count($oiddevice,"1.3.6.1.4.1.52.1011")>0):
	  $typdevice = "ELS100";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.52.4.2.4")>0):
	  $typdevice = "switch";
	  break;
	default:
	  $typdevice = "other";  // hub
	  break;
   }
   return $typdevice;
}


/* ************************************************************************
 Trunk : should return an array like in order to be independant for vendors
 $result[interfaceindex] = "0" no trunk "1","2",... for other state;
*/
function cabletronTrunk($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);

 $snmpok=0;
 $result= array();
 $msg = "Error: no response";
 // only for switches
 $typdevice = cabletronChecktypdevice($obj);
 if ($typdevice == "ELS100") {
 } else $msg = "Error: no MIB found";
 $objdevice->result= $result;
 if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG cabletron Trunk result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 VLAN : should return an array like in order to be independant for vendors
 $result["state"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["VlanID"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["index"][vlanindex] = ifindex;
 $result["nbport_by_vlan"][vlanindex] = nb ports in vlan
 $result["port_by_vlan"][vlanindex][] = array of ports in vlan
 $result["vlan_by_port"][vlanindex][] = array of ports in vlan
 $result["otherinfos"][] = array of other infos
 */
function cabletronVLAN($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $vlanstate= array(); 
 $vlanname = array(); 
 $vlanindex = array();
 $arrayofnbportsinvlan = array();
 $arrayofportsinvlan = array();
 $result["index"] = array();
 $result["state"] = array();
 $result["VlanID"] = array();
 $result["nbport_by_vlan"] = array();
 $result["port_by_vlan"] = array();
 $msg = "Error: MIB not exist.";
 $typdevice = cabletronChecktypdevice($obj);
 if ($typdevice == "ELS100") {
  $a_xmlmib = array(array("source"=>"ctels100-ng-MIB.xml"));
  /* search the VLAN information */
  // is global vlan activated 
  $globalvlan = 0;
  searchin_xmlMIB($a_xmlmib,"els100SwitchVlanEnable",$valmib);
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron global VLAN state MIB is ->".print_r($valmib,true)."\n");
  if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok1=$objdevice->retcode;
   /* give disable 1, enable 2 */
   if ($snmpok1) {
   	$globalvlan = (is_int($objdevice->result) && ($objdevice->result=="2"))? 1: 0;
        $msg= "";
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron global VLAN state array ->".$globalvlan."\n");
  }
  // continue only if global vlan activated
  if ($globalvlan) {
   searchin_xmlMIB($a_xmlmib,"els100SwitchVlanStatus",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN state MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
    networkclass_give_snmp($objdevice,$valmib);
    $snmpok1=$objdevice->retcode;
    /* give activated(1) notActivated(2 or 3) */
    /* we want "0" no vlan active "1","2",... for other state" */
    if ($snmpok1) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanstate);
        foreach ($vlanstate as $index => $value) if ($vlanstate[$index]!="1") $vlanstate[$index]="0";
        $msg= "";
    }
    else {
        $msg = $objdevice->errormsg;
    }
    if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN state array ->".print_r($vlanstate,true)."\n");
   }
   searchin_xmlMIB($a_xmlmib,"els100SwitchVlanName",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN name MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
    networkclass_give_snmp($objdevice,$valmib);
    $snmpok2=$objdevice->retcode;
    if ($snmpok2) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanname);
    }
    else {
        $msg = $objdevice->errormsg;
    }
    if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN vlanname ->".print_r($vlanname,true)."\n");
   }
   searchin_xmlMIB($a_xmlmib,"els100SwitchVlanId",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN VLanId MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
    networkclass_give_snmp($objdevice,$valmib);
    $snmpok3=$objdevice->retcode;
    if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanindex);
    }
    else {
        $msg = $objdevice->errormsg;
    }
    if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN VLanId ->".print_r($vlanindex,true)."\n");
   }
   searchin_xmlMIB($a_xmlmib,"els100SwitchVlanPorts",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron Port els100SwitchVlanPorts MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
    networkclass_give_snmp($objdevice,$valmib);
    $snmpok3=$objdevice->retcode;
    if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) {
   	  convert_index_to_ifindex($objdevice->result,$arrayofvlanlisttemp);
          $arrayofvlanlist = array();
           foreach ($arrayofvlanlisttemp as $ndx => $str) {
   	    $arrayofvlanlist[$ndx] = array();
   	    $val ="";
   	    $j=0;
   	    for($i = 0; $i < strlen($str); $i++) {
   	       $sbstr =substr($str, $i, 1);
               if (($sbstr!=":")&&($sbstr!=" ")) {
               	 $xval = intval('0x'.$sbstr,16);
               	 if ($xval & 0x8) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
               	   $arrayofvlanlist[$ndx][$j] =$val2;
               	 $j++;
               	 if ($xval & 0x4) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
               	   $arrayofvlanlist[$ndx][$j] =$val2;
               	 $j++;
               	 if ($xval & 0x2) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
                   $arrayofvlanlist[$ndx][$j] =$val2;
               	 $j++;
               	 if ($xval & 0x1) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
               	   $arrayofvlanlist[$ndx][$j] =$val2;
               	 $j++;
               	}
            }
          }
          foreach ($arrayofvlanlist as $ndx => $str) {
   	    $arrayofnbportsinvlan[$ndx] = substr_count($str,"1");
   	  }
   	}
    }
    else $msg = $objdevice->errormsg;
    if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG cabletron Port els100SwitchVlanPorts ->".print_r($PortActorAdminState,true)."\n");
   }
   $objdevice->give("ifIndex");
   if ($obdevice->retcode) {
     if (sizeof($objdevice->result)>0) {
      convert_index_to_ifindex($obdevice->result,$theindex);
       $d=0;
      foreach ($theindex as $indx => $val) {
      	$dx2="";
        foreach ($arrayofvlanlist as $dx => $val2) {
           $array1 = @$val2;
      	   $isch = (isset($array1[$d])) ?$array1[$d]:"0";
      	   if ($isch=="1") $dx2= $dx;
        }
      	$arrayofportsinvlan[$indx] = $dx2;
      	$d++;
      }
    }
    else $msg = $objdevice->errormsg;
    if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG cabletron Port Vlan Ports ->".print_r($PortActorAdminState,true)."\n");
   } 
   $result["index"] = @$vlanindex;
   $result["state"] = @$vlanstate;
   $result["VlanID"] = @$vlanname;
   $result["nbport_by_vlan"] = @$arrayofnbportsinvlan;
   $result["port_by_vlan"] = @$arrayofportsinvlan;
   $result["vlan_by_port"] = array();
   foreach ($arrayofportsinvlan as $vlanID => $tport) {
    foreach ($tport as $ndx => $port) {
     $result["vlan_by_port"][$port][] = $vlanID;
    }
   }
  }
 }
 $objdevice->result= $result;
 if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG cabletron VLAN result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok1;
 return $snmpok1;
}

/* ************************************************************************
 Channel : should return an array with all type of channel like ... in order
  to be independant for vendors who have severals channel types
 $result["channelindex"][0..x]=channeltype (at least "LACP")
 $result["LACP"]["AdminKey"][ifIndex] = AdminKey of LaCP channel;  // "dot3adAggPortActorAdminKey"
 $result["LACP"]["OperKey"][ifIndex] = OperKey of LaCP channel;    // "dot3adAggPortActorOperKey"
 $result["LACP"]["PortSelectedAggID"][ifIndex] = Port Selected in which index of the LaCP channel // "dot3adAggPortSelectedAggID"
 $result["LACP"]["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel // "dot3adAggPortActorOperState"
 
 $result["other type of channel"]["PortActorOperState"][ifIndex] = ...;     "..."
 $result["other type of channel"]["pagpGroupIfIndex"][ifIndex] = Port Attached in which index of the ... channel or 0 for not attached
 ....
 */
function cabletronChannel($objdevice) {
 networkclass_LACP($objdevice);
 $snmpok1 = $objdevice->retcode;
 $lacp = $objdevice->result;
 $result["channelindex"][0] = "LACP";
 $result["LACP"] = $lacp;
 $snmpok = $snmpok1;
 $objdevice->result =$result;
 if ($snmpok) $objdevice->errormsg = "";
 return $snmpok;
}

/* ************************************************************************
 LACP : should return an array like in order to be independant for vendors
 per default IEEE8023-LAG-MIB
 $result["AdminKey"][ifIndex] = AdminKey of LaCP channel;   "dot3adAggPortActorAdminKey"
 $result["OperKey"][ifIndex] = OperKey of LaCP channel;     "dot3adAggPortActorOperKey"
 $result["PortActorAdminState"][ifIndex] = Port Selected in which index of the LaCP channel
 $result["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel
 */
function cabletronLACP($objdevice) {
 networkclass_LACP($objdevice);
 return $objdevice->retcode;
}

/* ************************************************************************
 CPU : should return an array like
 $result["firstaveragename"][0] = value 1. average;
 $result["2averagename"][0] = value 2. average;
 $result["3averagename"][0] = value 3. average;
 .....
*/
function cabletronCPU($objdevice) {
 $result["1Sec"] = 0;
 $result["5Sec"] = 0;
 $result["1min"] = 0;
 $ret=0;
 $msg = "Error: CPU status not enabled or not supported.";
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $ret;
 return $ret;
}

/* ************************************************************************
 Temperature : should return an array of temperature (in degres Celsius) like
 $result["modulename"][0] = modulename; or ""
 $result["mean"][0] = 0;
 $result["min"][0] = value; or ""
 $result["max"][0] = value; or ""
 $result["state"][0] = value; or ""
PS: Fahrenheit to celsius (F - 32) / 1.8
*/
function cabletronTemperature($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $a_xmlmib = array(array("source"=>"ctron-environment-mib.xml"));
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron Temperature Load MIB ->".print_r($a_xmlmib,true)."\n");
 $result=array();
 $snmpok=0;
 $msg = "cisco EnvMonTemperatureStatusTable not enabled or not supported.";
 $mib = "chEnvAmbientTemp";
 searchin_xmlMIB($a_xmlmib,$mib,$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron Temperature MIB search of $mib ->".print_r($valmib,true)."\n");
 $snmpok1=(sizeof($valmib)>0);
 networkclass_give_snmp($objdevice,$valmib);
 $snmpok=$objdevice->retcode;
 if ($snmpok) {
  $result["mean"][0] = $objdevice->result;
  $msg = "";
 }
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG cabletron Temperature result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

function cabletronTFTPtransfert($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
  $state = array('other' => "1"
             ,'unknown' => "2"
             ,'normalOperation' => "3"
             ,'downLoadActive' => "4"
             ,'downLoadCompleteError' => "5"
           );
  $operation = array(
                "normalOperation"  => '1'
                ,"forceDownLoad"  => '2'
                ,"forceDownLoadReset"  => '3'
                ,"downLoadConfiguration"  => '4'
                ,"upLoadConfiguration"  => '5'
	   );
 $oid = array(
                "ctDLOnLineDownLoad" => '.1.3.6.1.4.1.52.4.1.5.8.1.16'
                ,"ctDLNetAddress"    => '.1.3.6.1.4.1.52.4.1.5.8.1.18'
                ,"ctDLFileName"      => '.1.3.6.1.4.1.52.4.1.5.8.1.19'
                ,"ctDLOperStatus"    => '.1.3.6.1.4.1.52.4.1.5.8.1.17'
                ,"ctDLErrorString"   => '.1.3.6.1.4.1.52.4.1.5.8.1.20'
             );
//force debug $objdevice->setdebug(true,true);
  if ($objdevice->tftpparam["source"]=="tftp") {
    $direction = $operation["downLoadConfiguration"];
  } else {
    $direction = $operation["upLoadConfiguration"];
  }
  $error ="";
  $ret_val ="";
  // set up the request
  $thefile = ($objdevice->tftpparam["source"]=='tftp') ? $objdevice->tftpparam["filesrc"]:$objdevice->tftpparam["filedest"];
  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oidIOS["ctDLNetAddress"], "type" => 'a', "value" => "".$objdevice->tftpparam["tftpip"])
 		// set the filename being written
 		,array("oid" => $oidIOS["ctDLFileName"], "type" => 's', "value" => $thefile)
 		// set file transfer direction
 		,array("oid" => $oidIOS["ctDLOnLineDownLoad"], "type" => 'i', "value" => $direction)
		);
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;
  if ($snmpok) {
		//set default status as "running"
		$result = $state["downLoadActive"];
		$snmpok= true;
		$j = 0;
		// check for the results status
		while ($snmpok && (($result == $state["downLoadActive"])&& ($j <10))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["ctDLOperStatus"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  if ($snmpok) {
		     if ($ret_val==$state["downLoadCompleteError"]) {
		     	$snmpok = false;
		     	$objdevice->get($oid["ctDLErrorString"]);
		     	$error = ($objdevice->retcode) ? $objdevice->result: "";
		     } else {
		     	$result = $ret_val;
		     }
		   } else $result= "";
		  sleep(1);
		  $j++; // not wait more than 10 seconds 
		}
  } else $ret_val= $error = "Error: SNMP Session failed before transfer";
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Cabletron TFTP transfert result is ".(($snmpok)?"OK":$error)."\n");
  $objdevice->result  = $ret_val;
  $objdevice->errormsg  = $error;
  $objdevice->retcode = $snmpok;
}

/* ************************************************************************
 TrapEvent : should return if the router has been changed in analysing the message of the syslog
 $result["changed"] = "running" "startup" or ""
 $result["host"] = host that has been changed;
 $result["date"] = 
 .....
!!!!!!!!!!!!! UNDER CONSTRUCTION !!!!!!!!!!!!!!!!!!!!!!!
*/
function cabletronTrapEvent($objdevice,$syslogmsg="") {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok = 1; // default always OK but no trap
 $result = array("changed" => ""
                ,"host" => ""
                ,"date" => ""
                );
 $msg    = "Error: no trap configuration events";
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

?>