<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************
    Author ......... Jean-Michel Pepin classes plugin for network devices (PEPJ in forum.cacti.net & http://cactiusers.org/forums/)
    Modified ....... .
    Program ........ class definition for Foundry network devices in PHP for Cacti or PHP software

    congratulation: For the TFTP part theses classes are based on the work of Pancho http://www.pancho.org
    & cacti http://www.cacti.net, 
    Thanks to all the developpers of cacti and pancho who make my work much easier for TFTP.
    TFTP pancho Foundry Charles Menzes 
*******************************************************************************/
/* define the OID of the vendor */
$toidvendor['foundry']      = '.1.3.6.1.4.1.1991';
$toidtovendor['.1.3.6.1.4.1.1991'] = 'foundry';

class foundrynetworkclass
{
   function vendorname($FunctionName)
   {
        return "foundry";       
   }
   function showclass()
   {
        return "this is a Foundry class";       
   }
   function priv($obj,$FunctionName,$param="")
   {
   	$fct = "Foundry".$FunctionName;
       	if (function_exists($fct)) $ret = ($param=="") ? $fct($obj) : $fct($obj,$param);
       	else {
       	  $ret=0;
          $obj->result= array();
          $obj->errormsg = "Error: Function does not exist.";
          $obj->retcode = $ret;
       	}
        return $ret;
   }
   function tftp($obj)
   {
     global $networkclass_isdebug,$networkclass_islog;
     if ($obj->inittftp) FoundryTFTPtransfer($obj);
   }
   /* return if the device is a host */
   function DeviceIsHost($objdevice,$init=false) {
     global $networkclass_isdebug,$networkclass_islog;
     // NEVER for Foundry class (only network devices)

     // the two following value could help you to find it
     // $obj->description();  // to be sure description has been ask at least one time
     // $description = $obj->result; or $description = $obj->description;
     // $oiddevice = $objdevice->oiddevice;
     //force debug $objdevice->setdebug(true,true);
     // if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG DeviceIsHost ->".print_r($valmib,true)."\n");
     if ($init) { $objdevice->ishost = false; }
     $result= $objdevice->ishost;
     return $result;
   }
}

/* return the type of the device (used only for the function in this class in case of a specific behaviour)
*/
function FoundryChecktypdevice($obj) {
   $description  = $obj->description;
   $oiddevice  = $obj->oiddevice;
   $typdevice = "unknow";
   $pattern1= '/serveriron/i';
   switch (true) {
	case preg_match($pattern1,$description)>0:
	  $typdevice = "serveriron";
	  break;
	default:
	  $typdevice = "other";
	  break;
   }
   return $typdevice;
}

/* return if the type of the device is a chassis model
*/
function FoundryChecktypchassis($obj) {
  $typdevice = false;
  $snmpok=0;
  $msg = "Error: snChasMainBrdId no response";
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Load MIB ->".print_r($a_xmlmib,true)."\n");
  $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
  $mib="snChasMainBrdId";
  searchin_xmlMIB($a_xmlmib,$mib,$valmib);
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry snChasMainBrdId MIB search of $mib ->".print_r($valmib,true)."\n");
  $pChasMainBrdId = array();
  $snmpok=(sizeof($valmib)>0);
  if ($snmpok) {
   networkclass_give_snmp($objdevice,$valmib,"i");
   $snmpok=$objdevice->retcode;
   if (($snmpok)&&(sizeof($objdevice->result)>0)) {
     	convert_index_to_ifindex($objdevice->result,$pChasMainBrdId);
   }
  }
  foreach ($pChasMainBrdId as $indx => $val) {
   $typdevice = ($val=="2") ? true:false;
   break;
  }
  return $typdevice;
}

/* ************************************************************************
 Duplex : should return an array like
 $result[ifindex] = 0 for unknow, 1 for half duplex, 2 for full duplex, 3 auto;
*/
function FoundryDuplex($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//$objdevice->setdebug(true,true); //force debug 
 $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
 $mib="snSwPortInfoChnMode";
 $mib2="snSwPortIfIndex";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Load MIB ->".print_r($a_xmlmib,true)."\n");
 $snmpok=0;
 $result = array();
 $msg = "Error: Duplex no response";
 searchin_xmlMIB($a_xmlmib,$mib,$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry MIB search of $mib ->".print_r($valmib,true)."\n");
 searchin_xmlMIB($a_xmlmib,$mib2,$valmib2);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Duplex index MIB search of $mib2 ->".print_r($valmib2,true)."\n");
 $snmpok=(sizeof($valmib)>0) && (sizeof($valmib2)>0);
 if ($snmpok) {
   networkclass_give_snmp($objdevice,$valmib);
   $pDuplex = $objdevice->result;
   $snmpok1 = $objdevice->retcode;
   networkclass_give_snmp($objdevice,$valmib2);
   $pDuplexindex = $objdevice->result;
   $snmpok2 = $objdevice->retcode;
   $snmpok = $snmpok1 && $snmpok2;
   if ($snmpok) {
     if ((sizeof($pDuplex)>0) && (sizeof($pDuplexindex)>0)) {
        remove_oid_for_find_index($valmib["oid"],$pDuplex,$result1);
        remove_oid_for_find_index($valmib2["oid"],$pDuplexindex,$result2);
        foreach ($result2 as $index => $val) {
        	$result[$val] = $result1[$index];
        }
     }
     // conversion for independancy reason
     foreach ($result as $index => $val) {
      switch ($val) {
	case 2: // full duplex
	  $res= 2;
	  break;
	case 1: // half duplex
	  $res= 1;
	  break;
	default:    //  0       other or unknown
	   $res= 0;
	  break;
      }
      $result[$index] =$res;
     }
     $msg = "";
   }
 }
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Duplex result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Trunk : should return an array like in order to be independant for vendors
 $result[interfaceindex] = "0" no trunk "1","2",... for other state;
*/
function FoundryTrunk($objdevice) {
// IN DEVELOPPEMENT
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
 $snmpok=0;
 $result= array();
 $msg = "Error: no response";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Trunk Load MIB ->".print_r($a_xmlmib,true)."\n");
 $mib="snSwGroupOperMode";
 searchin_xmlMIB($a_xmlmib,$mib,$valmib);
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   if ($objdevice->retcode) {
    if ($objdevice->result=="2") {
     $mib="snSwPortVlanId"; //snMSTrunkPortList";
     searchin_xmlMIB($a_xmlmib,$mib,$valmib);
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Trunk MIB search of $mib ->".print_r($valmib,true).", result=>".$objdevice->result."\n");
     if (sizeof($valmib)>0) {
       networkclass_give_snmp($objdevice,$valmib);
       /* 1 : trunking 2 : notTrunking */
       $result= $objdevice->result;
       $snmpok=$objdevice->retcode;
       $msg = $objdevice->errormsg;
     } else {
    	// no error but no trunk no vlan
    	$msg = "Error: MIB FoundryTrunk not found.";
    	$snmpok= 1;
     }
    } else {
    	// no error but no trunk no vlan
    	$msg = "";
    	$snmpok= 1;
    }
   }
 } else $msg = "Error: no MIB found";
 $objdevice->result= $result;
 if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG Foundry Trunk result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 VLAN : should return an array like in order to be independant for vendors
 $result["state"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["vlanname"][vlanindex] = "0" for no VLAN or VLAN number;
 $result["index"][vlanindex] = ifindex;
 $result["nbport_by_vlan"][vlanindex] = nb ports in vlan
 $result["port_by_vlan"][vlanindex][] = array of ports in vlan
 $result["vlan_by_port"][vlanindex][] = array of ports in vlan
 $result["otherinfos"][] = array of other infos
 */
function FoundryVLAN($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $vlanstate= array(); 
 $vlanname = array(); 
 $vlanindex = array();
 $arrayofnbportsinvlan = array();
 $arrayofportsinvlan = array();
 $snmpok=0;
 $msg = "Error: MIB not exist.";
 $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
 /* search the VLAN information */
 searchin_xmlMIB($a_xmlmib,"snVLanByPortOperState",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN state MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok1=$objdevice->retcode;
   /* give activated(1) notActivated(0) */
   /* we want "0" no vlan active "1","2",... for other state" */
   if ($snmpok1) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanstate);
        foreach ($vlanstate as $index => $value) if ($vlanstate[$index]!="1") $vlanstate[$index]="0";
        $msg= "";
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN state array ->".print_r($vlanstate,true)."\n");
 }
 searchin_xmlMIB($a_xmlmib,"snVLanByPortVLanName",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN name MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok2=$objdevice->retcode;
   if ($snmpok2) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanname);
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN vlanname ->".print_r($vlanname,true)."\n");
 }
 searchin_xmlMIB($a_xmlmib,"snVLanByPortVLanId",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN snVLanByPortVLanId MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok3=$objdevice->retcode;
   if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanindex);
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN snVLanByPortVLanId ->".print_r($vlanindex,true)."\n");
 }

 searchin_xmlMIB($a_xmlmib,"snVLanByPortMemberVLanId",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Port snVLanByPortMemberVLanId MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok3=$objdevice->retcode;
   if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$arrayofvlanlist);
   	foreach ($vlanindex as $i => $vlan) {
   	 $nbr=0;
   	 $arrayofportsinvlan[$vlan]=array(); 
   	 foreach ($arrayofvlanlist as $ifndx => $ifvlan) {
   	  if ($ifvlan==$vlan) {
   	  	$nbr=$nbr+1;
   	  	$arrayofportsinvlan[$vlan][$nbr]= $ifndx;
   	  }
   	 }
   	 $arrayofnbportsinvlan[$vlan]=$nbr;
   	}
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN Port snVLanByPortMemberVLanId ->".print_r($vlanindex,true)."\n");
 }
 /* convert to ifindex !!!!!*/
 $result["index"] = @$vlanindex;
 $result["state"] = @$vlanstate;
 $result["VlanID"] = @$vlanname;
 $result["nbport_by_vlan"] = @$arrayofnbportsinvlan;
 $result["port_by_vlan"] = @$arrayofportsinvlan;
 $result["vlan_by_port"] = array();
 foreach ($arrayofportsinvlan as $vlanID => $tport) {
  foreach ($tport as $ndx => $port) {
   $result["vlan_by_port"][$port][] = $vlanID;
  }
 }
 $objdevice->result= $result;
// if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG Foundry VLAN result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok1;
 return $snmpok1;
}

/* ************************************************************************
 Channel : should return an array with all type of channel like ... in order
  to be independant for vendors who have severals channel types
 $result["channelindex"][0..x]=channeltype (at least "LACP")
 $result["LACP"]["AdminKey"][ifIndex] = AdminKey of LaCP channel;  // "dot3adAggPortActorAdminKey"
 $result["LACP"]["OperKey"][ifIndex] = OperKey of LaCP channel;    // "dot3adAggPortActorOperKey"
 $result["LACP"]["PortActorAdminState"][ifIndex] = Port Selected in which index of the LaCP channel // "dot3adAggPortActorAdminState"
 $result["LACP"]["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel // "dot3adAggPortActorOperState"
 
 $result["other type of channel"]["PortActorOperState"][ifIndex] = ...;     "..."
 $result["other type of channel"]["pagpGroupIfIndex"][ifIndex] = Port Attached in which index of the ... channel or 0 for not attached
 ....
 */
function FoundryChannel($objdevice) {
 networkclass_LACP($objdevice);
 $snmpok1 = $objdevice->retcode;
 $lacp = $objdevice->result;
 $result["channelindex"][0] = "LACP";
 $result["LACP"] = $lacp;
 $snmpok = $snmpok1;
 $objdevice->result =$result;
 if ($snmpok) $objdevice->errormsg = "";
 return $snmpok;
}

/* ************************************************************************
 LACP : should return an array like in order to be independant for vendors
 per default IEEE8023-LAG-MIB
 $result["AdminKey"][ifIndex] = AdminKey of LaCP channel;   "dot3adAggPortActorAdminKey"
 $result["OperKey"][ifIndex] = OperKey of LaCP channel;     "dot3adAggPortActorOperKey"
 $result["PortActorAdminState"][ifIndex] = Port Selected in which index of the LaCP channel
 $result["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel
 */
function FoundryLACP($objdevice) {
 networkclass_LACP($objdevice);
 return $objdevice->retcode;
}

/* ************************************************************************
 CPU : should return an array like
 $result["firstaveragename"][0] = value 1. average;
 $result["2averagename"][0] = value 2. average;
 $result["3averagename"][0] = value 3. average;
*/
function FoundryCPU($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//$objdevice->setdebug(true,true);
 $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
 $snmpok=0;
 $result["1Sec"] = 0;
 $result["5Sec"] = 0;
 $result["1min"] = 0;
 $msg = "Error: CPU no response";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry CPU Load MIB ->".print_r($a_xmlmib,true)."\n");
 $mib="snAgGblCpuUtil1SecAvg";
 searchin_xmlMIB($a_xmlmib,$mib,$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry CPU MIB search of $mib ->".print_r($valmib,true)."\n");
 $snmpok=(sizeof($valmib)>0);
 if ($snmpok) {
   networkclass_give_snmp($objdevice,$valmib);
   $v1SecAvg = $objdevice->result;
   $snmpok = $objdevice->retcode;
   if ($snmpok) {
    $result["1Sec"] = $v1SecAvg;
    $mib="snAgGblCpuUtil5SecAvg";
    searchin_xmlMIB($a_xmlmib,$mib,$valmib);
    if ($objdevice->retcode) $result["5Sec"] = $objdevice->result;
    else $result["5Sec"] = "N/A";
    $mib="snAgGblCpuUtil1MinAvg";
    searchin_xmlMIB($a_xmlmib,$mib,$valmib);
    if ($objdevice->retcode) $result["1min"] = $objdevice->result;
    else $result["1min"] = "N/A";
    $snmpok=1;
    $msg = ""; 
   }
 }
 $objdevice->result= $result;
 if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG Foundry CPU result ->".print_r($result,true)."\n");
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Temperature : should return an array of temperature (in degres Celsius) like
 $result["modulename"][0] = modulename; or ""
 $result["mean"][0] = 0;
 $result["min"][0] = value; or ""
 $result["max"][0] = value; or ""
 $result["state"][0] = value; or ""
PS: Fahrenheit to celsius (F - 32) / 1.8
*/
function FoundryTemperature($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//$objdevice->setdebug(true,true);
 $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
 $snmpok=0;
 $result=array();
 $msg = "Error: Foundry Temperature Status Table not enabled or not supported.";
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry temperature Load MIB ->".print_r($a_xmlmib,true)."\n");
 searchin_xmlMIB($a_xmlmib,"snChasActualTemperature",$valmib);
 if (($networkclass_isdebug) || ($networkclass_islog) ) networkclass_debug("DEBUG Foundry temperature MIB search ->".print_r($valmib,true)."\n");
 $snmpok=(sizeof($valmib)>0);
 if ($snmpok) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok = $objdevice->retcode;
   if ($snmpok) {
     $tempcur = intval($objdevice->result/2); // because unit of 0.5 degres
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry temperature current ->".$tempcur.", is ok?".intval($snmpok)."\n");
     $result["mean"][0] = $tempcur;
     $msg = "";
   }
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Fan : should return an array of Fan state () like
 $result["description"][index] = decription where index is the index number of the fan
 $result["state"][index] = "ok" or "down" "not present" are mandatory for functioning / not functioning , or an another text
*/
function FoundryFan($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Fan Load MIB ->".print_r($a_xmlmib,true)."\n");
 $snmpok=0;
 $msg = "Foundry snChasFanDescription not enabled or not supported.";
 $mib = "snChasFanDescription";
 searchin_xmlMIB($a_xmlmib,$mib,$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Fan description MIB search of $mib ->".print_r($valmib,true)."\n");
 $snmpok1=(sizeof($valmib)>0);
 networkclass_give_snmp($objdevice,$valmib);
 if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$tdescription);
 else  $tdescription= array();
 $ok1=$objdevice->retcode;
 $tstate = array();
 if ($ok1) {
   $mib="snChasFanOperStatus";
   searchin_xmlMIB($a_xmlmib,$mib,$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Fan state MIB search of $mib ->".print_r($valmib,true)."\n");
   networkclass_give_snmp($objdevice,$valmib);
   if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$tstate);
   $ok2=$objdevice->retcode;
   if ($ok2) {
     foreach($tstate as $index => $val) {
      switch ($val) {
        // by other1 normal 2 failure 3
      	case 1:
      	  $tstate[$index] = "not present";
      	  break;
      	case 2:
      	  $tstate[$index] = "ok";
      	  break;
      	case 3:
      	  $tstate[$index] = "critical";
      	  break;
      	default:
      	  $tstate[$index] = "not Functioning";
      }
     }
   }
 }
 $snmpok = $ok1 && $ok2;
 $result["description"] = $tdescription;
 $result["state"] = $tstate;
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Fan result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 RAM : should return an array of RAM (processor)
 $result["RAM"] = 
 $result["RAMused"] = 
*/
function FoundryRAM($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
  $result = array();
  $snmpok=0;
  $msg = "Error: RAM status table not enabled or not supported.";
  $objdevice->result= $result;
  $objdevice->errormsg = $msg;
  $objdevice->retcode = $snmpok;
  return $snmpok;
}

/* ************************************************************************
 MAC : for the VlanID should return an array of MAC addresses like
 $result[interfaceindex][indexMAC] -> Macaddress where interfaceindex is the inteface index
*/
function FoundryMAC($objdevice,$vlanID) {
 networkclass_MAC($objdevice,$vlanID);
 return $objdevice->retcode;
}

/* ************************************************************************
 STPchanges : for the VlanID should return an array of 
 $result["TopChanges"] -> The total number of topology changes detected by this bridge since the management entity was last reset or initialized.
 $result["TimeSinceTopologyChange"] -> The time (in hundredths of a second) since the last time a topology change was detected by the bridge entity.
*/
function FoundrySTPchanges($objdevice,$vlanID="") {
 networkclass_STPchanges($objdevice,$vlanID);
 return $objdevice->retcode;
}

/* ************************************************************************
 Serialnumber : should return an array like
 $result[0..xx] = array("description" -> description, "SN" -> serial number);
 IN DEVELOPEMENT
*/
/*
function FoundrySerialnumber($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//$objdevice->setdebug(true,true);  //force manual debug
  $snmpok=0;
  $result = array();
  $ischassis = FoundryChecktypchassis($objdevice);
  $msg = "Error: Serial number no response";
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Serial number Load MIB ->".print_r($a_xmlmib,true)."\n");
  $a_xmlmib = array(array("source"=>"foundry-mib.xml"));
  if (!$ischassis) {
    $mib="snChasMainBrdDescription";
    $mib2="snChasSerNum";
  } else {
    $mib ="snChasMainBrdDescription"; // pas encore fini !!!!!!!!!! faire par le "product"
    $mib2="snChasSerNum";
    $mib3="snAgentConfigModuleDescription";
    $mib4="snAgentConfigModuleSerialNumber";
  }
  searchin_xmlMIB($a_xmlmib,$mib,$valmib);
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry module description MIB search of $mib ->".print_r($valmib,true)."\n");
  searchin_xmlMIB($a_xmlmib,$mib2,$valmib2);
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry module Serialnumber MIB search of $mib2 ->".print_r($valmib2,true)."\n");
  $snmpok=(sizeof($valmib)>0) && (sizeof($valmib2)>0);
  if ($snmpok) {
   networkclass_give_snmp($objdevice,$valmib);
   $pDuplex = $objdevice->result;
   $snmpok1 = $objdevice->retcode;
   networkclass_give_snmp($objdevice,$valmib2);
   $pDuplexindex = $objdevice->result;
   $snmpok2 = $objdevice->retcode;
   $snmpok = $snmpok1 && $snmpok2;
   if ($snmpok) {
     if ((sizeof($pDuplex)>0) && (sizeof($pDuplexindex)>0)) {
        remove_oid_for_find_index($valmib["oid"],$pDuplex,$result1);
        remove_oid_for_find_index($valmib2["oid"],$pDuplexindex,$result2);
        foreach ($result2 as $index => $val) {
        	$result[$val] = $result1[$index];
        }
     }
    $msg = "";
   }
  }

 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry Serialnumber result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}
*/

// set the command no snmp-server pw-check
// here not activ Set an enable password snAgGblPassword .1.3.6.1.4.1.1991.1.1.2.1.15.0 your enable password 
function FoundryTFTPtransfer($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $oid = array(
		"tftpserver"	=> ".1.3.6.1.4.1.1991.1.1.2.1.5.0", //snAgTftpServerIp
		"filename"	=> ".1.3.6.1.4.1.1991.1.1.2.1.8.0", //snAgCfgFname
		"action"	=> ".1.3.6.1.4.1.1991.1.1.2.1.9.0" //snAgCfgLoad
             );
  $fromtftp = array("start"     => '21',
                   "run"        => '23',
                   "dram"       => '30'
                );
  $totftp = array("start"       => '20',
                   "run"        => '22'
                );
  $state = array("normal"=>  "1"
            ,"flashPrepareReadFailure" =>  "2" 
            ,"flashReadError" => "3"
            ,"flashPrepareWriteFailure" => "4"
            ,"flashWriteError" => "5"
            ,"tftpTimeoutError" => "6"
            ,"tftpOutOfBufferSpace" => "7"
            ,"tftpBusy" => "8"
            ,"tftpRemoteOtherErrors" => "9"
            ,"tftpRemoteNoFile" => "10"
            ,"tftpRemoteBadAccess" => "11"
            ,"tftpRemoteDiskFull" => "12"
            ,"tftpRemoteBadOperation" => "13"
            ,"tftpRemoteBadId" => "14"
            ,"tftpRemoteFileExists" => "15"
            ,"tftpRemoteNoUser" => "16"
            ,"operationError" => "17"
            ,"loading" => "18"
            ,"tftpWrongFileType" => "29"
           );
           
  if ($objdevice->tftpparam["source"]=="tftp") {
    $direction = ($objdevice->tftpparam["filedest"]=="run") ? $fromtftp["run"] : $fromtftp["start"];
  } else {
    $direction = ($objdevice->tftpparam["source"]=="start") ? $totftp["start"] : $totftp["run"];
  }
  $error ="";
  $ret_val ="";
  // set up the request
  $thefile = ($objdevice->tftpparam["source"]=='tftp') ? $objdevice->tftpparam["filesrc"]:$objdevice->tftpparam["filedest"];
  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["tftpserver"], "type" => 'a', "value" => "".$objdevice->tftpparam["tftpip"])
 		// set the filename being written
 		,array("oid" => $oid["filename"], "type" => 's', "value" => $thefile)
 		// set file transfer direction
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $direction)
		);
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;
  if ($snmpok) {
		//set default status as "running"
		$result = $state["loading"];
		$snmpok= true;
		$j = 0;
		// check for the results status
		while ($snmpok && (($result == $state["loading"]) && ($j <10))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["action"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  if ($snmpok)
		     $result = $ret_val;
		   else $result= "";
              sleep(1);
		  $j++; // not wait more than 10 seconds 
		}
  }
  if (!$snmpok) {
     	$ret_val= $error = "Error: SNMP Session failed during transfer";
	$snmpok = 0;
  }
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Foundry TFTP transfert result is ".(($snmpok)?"OK":$error)."\n");
  $objdevice->result  = $ret_val;
  $objdevice->errormsg  = $error;
  $objdevice->retcode = $snmpok;
}

?>