<?php
/*
 +-------------------------------------------------------------------------+
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/
/*******************************************************************************
    Author ......... Jean-Michel Pepin classes plugin for network devices (PEPJ in forum.cacti.net & http://cactiusers.org/forums/)
    Modified ....... .
    Program ........ class definition for Nortel network devices in PHP for Cacti or PHP software

    congratulation: For the TFTP part theses classes are based on the work of Pancho http://www.pancho.org
    & cacti http://www.cacti.net, 
    Thanks to all the developpers of cacti and pancho who make my work much easier for TFTP.
    TFTP Nortel Alteon & Accelar & Avaya & Baystack & Passport Jean-Francois Taltavull,
    TFTP Nortel rapidcity Jean-Michel Ppin
    references: RAPID-CITY.mib
*******************************************************************************/
/* define the OID of the vendor */
$toidvendor['nortel']       = '.1.3.6.1.4.1.45'; //Nortel Baystack
$toidvendor['alteon']       = '.1.3.6.1.4.1.1872';
$toidvendor['rapidcity']       = '.1.3.6.1.4.1.2272'; //  'norway'
$toidtovendor['.1.3.6.1.4.1.45'] = 'nortel';
$toidtovendor['.1.3.6.1.4.1.1872'] = 'nortel';
$toidtovendor['.1.3.6.1.4.1.2272'] = 'nortel';

class nortelnetworkclass
{
   function vendorname($FunctionName)
   {
        return "nortel";       
   }
   function showclass()
   {
        return "this is a nortel class";       
   }
   function priv($obj,$FunctionName,$param="")
   {
   	$fct = "nortel".$FunctionName;
   	if (function_exists($fct)) $ret = ($param=="") ? $fct($obj) : $fct($obj,$param);
       	else {
       	  $ret=0;
          $obj->result= array();
          $obj->errormsg = "Error: Function does not exist.";
          $obj->retcode = $ret;
       	}
        return $ret;
   }
   function tftp($obj)
   {
     global $networkclass_isdebug,$networkclass_islog;
     if ($obj->inittftp) {
     	nortelTFTPtransfert($obj);
     }
   }
   /* return if the device is a host */
   function DeviceIsHost($objdevice,$init=false) {
     global $networkclass_isdebug,$networkclass_islog;
     // NEVER for nortel class (only network devices)

     // the two following value could help you to find it
     // $obj->description();  // to be sure description has been ask at least one time
     // $description = $obj->result; or $description = $obj->description;
     // $oiddevice = $objdevice->oiddevice;
     //force debug $objdevice->setdebug(true,true);
     // if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG DeviceIsHost ->".print_r($valmib,true)."\n");
     if ($init) { $objdevice->ishost = false; }
     $result= $objdevice->ishost;
     return $result;
   }
}

/* return the type of the device (used only for the function in this class in case of a specific behaviour)
*/
function nortelChecktypdevice($obj) {
   $description  = $obj->description;
   $oiddevice  = $obj->oiddevice;
   $typdevice = "unknow";
   switch (true) {
	case (substr_count($oiddevice,"1.3.6.1.4.1.45")>0):
	  $typdevice = "nortel";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.1872")>0):
	  $typdevice = "alteon";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.2272")>0):
	  $typdevice = "rapidcity";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.2272.1.2")>0):
	  $typdevice = "rapidcity,accelar";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.2272.1.100.7")>0):
	  $typdevice = "rapidcity,passport";
	  break;
	case (substr_count($oiddevice,"1.3.6.1.4.1.1872")>0):
	  $typdevice = "rapidcity,alteon";
	  break;
	default:
	  $typdevice = "other";
	  break;
   }
   return $typdevice;
}

/* ************************************************************************
 Duplex : should return an array like
 $result[ifindex] = 0 for unknow, 1 for half duplex, 2 for full duplex, 3 auto;
*/
function nortelDuplex($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//$objdevice->setdebug(true,true);  //force manual debug
  $snmpok=0;
  $result = array();
  $msg = "Error: Duplex no response";
  $typ = nortelChecktypdevice($objdevice);
  if (substr_count($typ,"rapidcity")>0) {
    $a_xmlmib = array(array("source"=>"RAPID-CITY-mib.xml"));
    $mib="rcPortAdminDuplex";
    $mib2="rcPortIndex";
    // if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel Duplex Load MIB ->".print_r($a_xmlmib,true)."\n");
    searchin_xmlMIB($a_xmlmib,$mib,$valmib);
    if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel Duplex MIB search of $mib ->".print_r($valmib,true)."\n");
    searchin_xmlMIB($a_xmlmib,$mib2,$valmib2);
    if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel Duplex index MIB search of $mib2 ->".print_r($valmib2,true)."\n");
    $snmpok=(sizeof($valmib)>0) && (sizeof($valmib2)>0);
    if ($snmpok) {
     networkclass_give_snmp($objdevice,$valmib);
     $pDuplex = $objdevice->result;
     $snmpok1 = $objdevice->retcode;
     networkclass_give_snmp($objdevice,$valmib2);
     $pDuplexindex = $objdevice->result;
     $snmpok2 = $objdevice->retcode;
     $snmpok = $snmpok1 && $snmpok2;
     if ($snmpok) {
      if ((sizeof($pDuplex)>0) && (sizeof($pDuplexindex)>0)) {
        remove_oid_for_find_index($valmib["oid"],$pDuplex,$result1);
        remove_oid_for_find_index($valmib2["oid"],$pDuplexindex,$result2);
        foreach ($result2 as $index => $val) {
        	$result[$val] = $result1[$index];
        }
       }
     if (substr_count($typ,"rapidcity")>0) {
       // conversion for independancy reason
       foreach ($result as $index => $val) {
         switch ($val) {
          case 2: // full duplex
	    $res= 2;
	    break;
	  case 1: // half duplex
	    $res= 1;
	    break;
	  default:    //  0       other or unknown
	     $res= 1;
	    break;
         }  
        $result[$index] =$res;
       }
     }
    $msg = "";
    }
   }
  } else {
   if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Nortel $typ Duplex UNDER CONSTRUCTION "."\n");
  }
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel Duplex result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Trunk : should return an array like in order to be independant for vendors
 $result[interfaceindex] = "0" no trunk "1","2",... for other state;
*/
function nortelTrunk($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);

 $snmpok=0;
 $result= array();
 $msg = "Error: no response";
 $typ = nortelChecktypdevice($objdevice);
 $a_xmlmib = array(array("source"=>"RAPID-CITY-mib.xml"));

 if (substr_count($typ,"rapidcity")>0) {
   searchin_xmlMIB($a_xmlmib,"rcVlanPortIndex",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ rcVlanPortIndex MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
     networkclass_give_snmp($objdevice,$valmib);
     $snmpok=$objdevice->retcode;
     if ($snmpok) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$portindex);
     }
     else {
        $msg = $objdevice->errormsg;
     }
     if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Trunk ->".print_r($portindex,true)."\n");
   }
   searchin_xmlMIB($a_xmlmib,"rcVlanPortType",$valmib2);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Trunk MIB is ->".print_r($valmib2,true)."\n");
   if (sizeof($valmib2)>0) {
     networkclass_give_snmp($objdevice,$valmib2);
     $snmpok2=$objdevice->retcode;
     if ($snmpok2) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$trunks);
   	// type of port: access(1) or trunk(2)
   	// we want "0" no trunk "1","2",... for other state
       foreach ($trunks as $index => $val) {
       	 $result[$portindex[$index]] = ($val=="2") ? "1": "0";
       }
     }
     else {
        $msg = $objdevice->errormsg;
     }
     if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Trunk ->".print_r($result,true)."\n");
   }
  } else {
    if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ Trunk UNDER CONSTRUCTION "."\n");
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok && $snmpok2;
 return $snmpok;
}

function nortelPortSet($PortSettemp,&$PortSet) {
          $PortSet = array();
           foreach ($PortSettemp as $ndx => $str) {
   	    $PortSet[$ndx] = array();
   	    $val ="";
   	    $j=0;
   	    for($i = 0; $i < strlen($str); $i++) {
   	       $sbstr =substr($str, $i, 1);
               if (($sbstr!=":")&&($sbstr!=" ")) {
               	 $xval = intval('0x'.$sbstr,16);
               	 if ($xval & 0x8) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
               	   $PortSet[$ndx][$j] =$val2;
               	 $j++;
               	 if ($xval & 0x4) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
               	   $PortSet[$ndx][$j] =$val2;
               	 $j++;
               	 if ($xval & 0x2) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
                   $PortSet[$ndx][$j] =$val2;
               	 $j++;
               	 if ($xval & 0x1) $val2="1"; else $val2= "0";
               	 if ($val2=="1") 
               	   $PortSet[$ndx][$j] =$val2;
               	 $j++;
               	}
            }
          }
}

/* ************************************************************************
 VLAN : should return an array like in order to be independant for vendors
 $result["state"][vlanindex] = "0" for not activ or "1" or VLAN number;
 $result["vlanname"][vlanindex] = "0" for no VLAN or VLAN name
 $result["index"][vlanindex] = ifindex;
 $result["nbport_by_vlan"][vlanindex] = nb ports in vlan
 $result["port_by_vlan"][vlanindex][] = array of ports in vlan
 $result["vlan_by_port"][vlanindex][] = array of ports in vlan
 $result["otherinfos"][] = array of other infos
 */
function nortelVLAN($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);

 $snmpok=0;
 $msg = "Error: no response";
 $vlanstate= array(); 
 $vlanname = array(); 
 $vlanindex = array();
 $arrayofnbportsinvlan = array();
 $arrayofportsinvlan = array();
 $VlanActiveMembers = array();
 $a_xmlmib = array();
 $typ = nortelChecktypdevice($objdevice);
// if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN Load MIB ->".print_r($a_xmlmib,true)."\n");
 if (substr_count($typ,"rapidcity")>0) {
   $a_xmlmib = array(array("source"=>"RAPID-CITY-mib.xml"));
   $mibvlanstate = "rcVlanActiveMembers";
 /* search the VLAN information */
 searchin_xmlMIB($a_xmlmib,$mibvlanstate,$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN state MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok1=$objdevice->retcode;
   /* Nortel give a PortSet */
   if ($snmpok1) {
   	if (sizeof($objdevice->result)>0) {
   	   convert_index_to_ifindex($objdevice->result,$VlanActiveMembersportset);
   	   nortelPortSet($VlanActiveMembersportset,$VlanActiveMembers);
           foreach ($VlanActiveMembers as $index => $value) {
             $vlanstate[$index]= (substr_count($VlanActiveMembers[$index],"1")>0) ? $index : "0";
             $arrayofnbportsinvlan[$index] = substr_count($VlanActiveMembers[$index],"1");
           }
   	}
        $msg= "";
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN state array ->".print_r($vlanstate,true)."\n");
 }
 searchin_xmlMIB($a_xmlmib,"rcVlanName",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN name MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok2=$objdevice->retcode;
   if ($snmpok2) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanname);
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN vlanname ->".print_r($vlanname,true)."\n");
 }
 searchin_xmlMIB($a_xmlmib,"rcVlanIfIndex",$valmib);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN rcVlanIfIndex MIB is ->".print_r($valmib,true)."\n");
 if (sizeof($valmib)>0) {
   networkclass_give_snmp($objdevice,$valmib);
   $snmpok3=$objdevice->retcode;
   if ($snmpok3) {
   	if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$vlanindex);
   }
   else {
        $msg = $objdevice->errormsg;
   }
   if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ VLAN rcVlanIfIndex ->".print_r($vlanindex,true)."\n");
 }
 /* VLAN based */
 $arrayofnbportsinvlan= array();
 $arrayofportsinvlan= array();
 if (sizeof($vlanindex)>0) {
   // we need this infomation only to find the ports for the vlans
   searchin_xmlMIB($a_xmlmib,"rcVlanPortIndex",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ rcVlanPortIndex MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
     networkclass_give_snmp($objdevice,$valmib);
     $snmpok4 = $objdevice->retcode;
     if ($snmpok4) {
       convert_index_to_ifindex($objdevice->result,$PortIndex);
       $tempportindex = array();
       $nb = 0;
       foreach ($PortIndex as $index => $value) {
       	 $tempportindex[$nb] = $value;
       	 $nb++;
        }
       foreach ($VlanActiveMembers as $index => $strports) {
   	  for($i = 0; $i < strlen($strports); $i++) {
   	     $sbstr =substr($strports, $i, 1);
             if (($sbstr=="1")&&(array_key_exists($i,$tempportindex)))
                $arrayofportsinvlan[$index][] = $tempportindex[$i];
   	  }
       }
     }
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ arrayofportsinvlan for vlans ->".print_r($arrayofnbportsinvlan,true)."\n");	
   }
 }
  } else {
  if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ VLAN UNDER CONSTRUCTION "."\n");
   $mibvlanstate = "";
 }

 /* convert to ifindex !!!!!*/
 $result["index"] = @$vlanindex;
 $result["state"] = @$vlanstate;
 $result["VlanID"] = @$vlanname;
 $result["nbport_by_vlan"] = @$arrayofnbportsinvlan;
 $result["port_by_vlan"] = @$arrayofportsinvlan;
 $result["vlan_by_port"] = array();
 foreach ($arrayofportsinvlan as $vlanID => $tport) {
  foreach ($tport as $ndx => $port) {
   $result["vlan_by_port"][$port][] = $vlanID;
  }
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 Channel : should return an array with all type of channel like ... in order
  to be independant for vendors who have severals channel types
 $result["channelindex"][0..x]=channeltype (at least "LACP")
 $result["LACP"]["AdminKey"][ifIndex] = AdminKey of LaCP channel;  // "dot3adAggPortActorAdminKey"
 $result["LACP"]["OperKey"][ifIndex] = OperKey of LaCP channel;    // "dot3adAggPortActorOperKey"
 $result["LACP"]["PortSelectedAggID"][ifIndex] = Port Selected in which index of the LaCP channel // "dot3adAggPortSelectedAggID"
 $result["LACP"]["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel // "dot3adAggPortActorOperState"
 
 $result["other type of channel"]["PortActorOperState"][ifIndex] = ...;     "..."
 $result["other type of channel"]["pagpGroupIfIndex"][ifIndex] = Port Attached in which index of the ... channel or 0 for not attached
 ....
 */
function nortelChannel($objdevice) {
 networkclass_LACP($objdevice);
 $snmpok1 = $objdevice->retcode;
 $lacp = $objdevice->result;
 $result["channelindex"][0] = "LACP";
 $result["LACP"] = $lacp;
 $snmpok = $snmpok1;
 $objdevice->result =$result;
 if ($snmpok) $objdevice->errormsg = "";
 return $snmpok;
}

/* ************************************************************************
 LACP : should return an array like in order to be independant for vendors
 per default IEEE8023-LAG-MIB
 $result["AdminKey"][ifIndex] = AdminKey of LaCP channel;   "dot3adAggPortActorAdminKey"
 $result["OperKey"][ifIndex] = OperKey of LaCP channel;     "dot3adAggPortActorOperKey"
 $result["PortSelectedAggID"][ifIndex] = Port Selected in which index of the LaCP channel
 $result["PortActorOperState"][ifIndex] = Port Attached in which index of the LaCP channel
 */
function nortelLACP($objdevice) {
 networkclass_LACP($objdevice);
 return $objdevice->retcode;
}

/* ************************************************************************
 CPU : should return an array like
 $result["firstaveragename"] = value 1. average;
 $result["2averagename"] = value 2. average;
 $result["3averagename"] = value 3. average;
 .....
*/
function nortelCPU($objdevice) {
 $result = array();
// $result["5Sec"] = 0;
// $result["1min"] = 0;
 $ret=0;
 $msg = "Error: CPU status not enabled or not supported.";
 $typ = nortelChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Nortel $typ CPU "."\n");
 if (substr_count($typ,"rapidcity")>0) {
   $a_xmlmib = array(array("source"=>"RAPID-CITY-mib.xml"));
   searchin_xmlMIB($a_xmlmib,"rcSysCpuUtil",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ rcSysCpuUtil MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
     networkclass_give_snmp($objdevice,$valmib);
     $snmpok=$objdevice->retcode;
     if ($snmpok) {
   	$result["mean"] = $objdevice->result;
     }
     else {
        $msg = $objdevice->errormsg;
     }
     if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ rcSysCpuUtil ->".print_r($result,true)."\n");
   }
 }
 elseif (substr_count($typ,"nortel")>0) {
  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Nortel $typ CPU UNDER CONSTRUCTION. not implemented yet"."\n");
 }
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $ret;
 return $ret;
}

/* ************************************************************************
 Temperature : should return an array of temperature (in degres Celsius) like
 $result["modulename"][0] = modulename; or ""
 $result["mean"][0] = 0;
 $result["min"][0] = value; or ""
 $result["max"][0] = value; or ""
 $result["state"][0] = state value; or ""
PS: Fahrenheit to celsius (F - 32) / 1.8
*/
function nortelTemperature($objdevice) {
  $result=array();
  $ret=0;
  $msg = "Error: Nortel $typ Temperature status table not enabled or not supported.";
  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Nortel $typ Temperature UNDER CONSTRUCTION "."\n");
  if (substr_count($typ,"rapidcity")>0) {
  }
  if (substr_count($typ,"nortel")>0) {
   $sourcexml= "nortel-synoptics-common-mib.xml";
   $a_xmlmib = array(array("source"=>$sourcexml));
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ Temperature Load MIB ->".print_r($a_xmlmib,true)."\n");
   // ************** not finished **************
   $mib = "s3RedPsAmbientTempStatus";
   searchin_xmlMIB($a_xmlmib,$mib,$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ state Temperature MIB search of $mib ->".print_r($valmib,true)."\n");
   $snmpok1=(sizeof($valmib)>0);
   networkclass_give_snmp($objdevice,$valmib);
   $result1 = $objdevice->result;
   $ok1=$objdevice->retcode;
   if ($ok1) {
     $result["state"][0] = $result1;
     $mib="s3RedPsAmbientTemperature";
     searchin_xmlMIB($a_xmlmib,$mib,$valmib);
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ AmbientTemperature MIB search of $mib ->".print_r($valmib,true)."\n");
     networkclass_give_snmp($objdevice,$valmib);
     $result2 = $objdevice->result;
     $ok2=$objdevice->retcode;
     if ($ok2) {
       $result["value"][0] = $result2;
       $snmpok=1;
     }
   }
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ Temperature result ->".print_r($result,true)."\n");
  }
  $objdevice->result= $result;
  $objdevice->errormsg = $msg;
  $objdevice->retcode = $ret;
  return $ret;
}

/* ************************************************************************
 Fan : should return an array of Fan state () like
 $result["description"][index] = decription where index is the index number of the fan
 $result["state"][index] = "ok" or "down" "not present" are mandatory for functioning / not functioning , or an another text
*/
function nortelFan($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $typ = nortelChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG Nortel $typ RAM"."\n");
 $snmpok=0;
 $tdescription = array();
 $tstate = array();
 $msg = "nortel $typ Fan not enabled or not supported.";
 $sourcexml="";
 if (substr_count($typ,"rapidcity")>0) {
   $sourcexml= "RAPID-CITY-mib.xml";
   $a_xmlmib = array(array("source"=>$sourcexml));
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Fan Load MIB ->".print_r($a_xmlmib,true)."\n");
   $mib1 = "rcChasFanId";
   $mib2 = "rcChasFanOperStatus";
   searchin_xmlMIB($a_xmlmib,$mib1,$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Fan description MIB search of $mib ->".print_r($valmib,true)."\n");
   $snmpok1=(sizeof($valmib)>0);
   networkclass_give_snmp($objdevice,$valmib);
   if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$tdescription);
   else  $tdescription= array();
   $ok1=$objdevice->retcode;
   if ($ok1) {
     searchin_xmlMIB($a_xmlmib,$mib2,$valmib);
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Fan state MIB search of $mib ->".print_r($valmib,true)."\n");
     networkclass_give_snmp($objdevice,$valmib);
     if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$tstate);
     $ok2=$objdevice->retcode;
     if ($ok2) {
       foreach($tstate as $index => $val) {
        if (substr_count($typ,"rapidcity")>0) {
           switch ($val) {
            // by nortel unknown(1),up(2),down(3)
       	  case 2:
       	    $tstate[$index] = "ok";
      	    break;
      	  case 3:
      	    $tstate[$index] = "down";
      	    break;
      	  default:
      	    $tstate[$index] = "not present";
         }
        }
       }
     }
   }
 } else
 if (substr_count($typ,"nortel")>0) {
   $sourcexml= "nortel-synoptics-common-mib.xml";
   $a_xmlmib = array(array("source"=>$sourcexml));
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Fan Load MIB ->".print_r($a_xmlmib,true)."\n");
   $mib1 = "none";
   $mib2 = "s3ChassisFanStatus";
   $ok1 = true;
   $tdescription = array(1=>"1");
   if ($ok1) {
     searchin_xmlMIB($a_xmlmib,$mib2,$valmib);
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Fan state MIB search of $mib ->".print_r($valmib,true)."\n");
     networkclass_give_snmp($objdevice,$valmib);
     $tstate[1] = $objdevice->result;
     $ok2=$objdevice->retcode;
     if ($ok2) {
       foreach($tstate as $index => $val) {
        if (substr_count($typ,"nortel")>0) {
           switch ($val) {
            // by nortel synoptics ok(1),fail(2),other(3)
       	  case 1:
       	    $tstate[$index] = "ok";
      	    break;
      	  case 2:
      	    $tstate[$index] = "down";
      	    break;
      	  default:
      	    $tstate[$index] = "not present";
         }
        }
       }
     }
   }
 }
 $snmpok = $ok1 && $ok2;
 $result["description"] = $tdescription;
 $result["state"] = $tstate;
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ Fan result ->".print_r($result,true)."\n");
 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

/* ************************************************************************
 RAM : should return an array of RAM 
 $result["total"] = 
 $result["used"] = 
 or 
 $result["MemoryAvailable"] =
 $result["MemoryMinAvailable"] =
*/
function nortelRAM($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
  $result = array();
  $ret=0;
  $msg = "Error: RAM status table not enabled or not supported.";
  $typ = nortelChecktypdevice($objdevice);
  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG Nortel $typ RAM"."\n");
  if (substr_count($typ,"rapidcity")>0) {
   $a_xmlmib = array(array("source"=>"RAPID-CITY-mib.xml"));
   searchin_xmlMIB($a_xmlmib,"rcSysNVRamSize",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ rcSysNVRamSize MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
     networkclass_give_snmp($objdevice,$valmib);
     $snmpok=$objdevice->retcode;
     if ($snmpok) {
   	$result["total"] = $objdevice->result;
     }
     else {
        $msg = $objdevice->errormsg;
     }
     searchin_xmlMIB($a_xmlmib,"rcSysNVRamUsed",$valmib);
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ rcSysNVRamUsed MIB is ->".print_r($valmib,true)."\n");
     if (sizeof($valmib)>0) {
       networkclass_give_snmp($objdevice,$valmib);
       $snmpok=$objdevice->retcode;
       if ($snmpok) {
   	$result["used"] = $objdevice->result;
   	if (array_key_exists("total",$result)) $result["free"] = $result["total"]-$result["used"];
       }
       else {
        $msg = $objdevice->errormsg;
       }
       if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ RAM ->".print_r($result,true)."\n");
     }
   }
  }
  if (substr_count($typ,"nortel")>0) {
   $a_xmlmib = array(array("source"=>"nortel-s5-chassis-mib.xml"));
   searchin_xmlMIB($a_xmlmib,"s5ChasUtilMemoryAvailable",$valmib);
   if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ s5ChasUtilMemoryAvailable MIB is ->".print_r($valmib,true)."\n");
   if (sizeof($valmib)>0) {
     networkclass_give_snmp($objdevice,$valmib);
     $snmpok=$objdevice->retcode;
     if ($snmpok) {
        if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$result["MemoryAvailable"]);
     }
     else {
        $msg = $objdevice->errormsg;
     }
     searchin_xmlMIB($a_xmlmib,"s5ChasUtilMemoryMinAvailable",$valmib);
     if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG nortel $typ MemoryAvailable MIB is ->".print_r($valmib,true)."\n");
     if (sizeof($valmib)>0) {
       networkclass_give_snmp($objdevice,$valmib);
       $snmpok=$objdevice->retcode;
       if ($snmpok) {
        if (sizeof($objdevice->result)>0) convert_index_to_ifindex($objdevice->result,$result["MemoryMinAvailable"]);
       }
       else {
        $msg = $objdevice->errormsg;
       }
       if (($networkclass_isdebug)||($networkclass_islog)) networkclass_debug("DEBUG nortel $typ MemoryMinAvailable ->".print_r($result,true)."\n");
     }
   }
  }	
  $objdevice->result= $result;
  $objdevice->errormsg = $msg;
  $objdevice->retcode = $ret;
  return $ret;
}

/* ************************************************************************
 MAC : for the VlanID should return an array of MAC addresses like
 $result[interfaceindex][indexMAC] -> Macaddress where interfaceindex is the inteface index
*/
function nortelMAC($objdevice,$vlanID) {
 networkclass_MAC($objdevice,$vlanID);
 return $objdevice->retcode;
}

/* ************************************************************************
 STPchanges : for the VlanID should return an array of 
 $result["TopChanges"] -> The total number of topology changes detected by this bridge since the management entity was last reset or initialized.
 $result["TimeSinceTopologyChange"] -> The time (in hundredths of a second) since the last time a topology change was detected by the bridge entity.
*/
function nortelSTPchanges($objdevice,$vlanID="") {
 networkclass_STPchanges($objdevice,$vlanID);
 return $objdevice->retcode;
}

function nortelTFTPPassporttransfert($objdevice,&$error,&$ret_val,&$snmpok) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok=0;
 $error ="";
 $ret_val="";
 $result ="";
 $oid = array(
		"filesource" => ".1.3.6.1.4.1.2272.1.100.7.1.0"
		,"filedest" => ".1.3.6.1.4.1.2272.1.100.7.2.0"
		,"action"	  => ".1.3.6.1.4.1.2272.1.100.7.3.0"
		,"result"    => ".1.3.6.1.4.1.2272.1.100.7.4.0"
             );
  $action = array( "none"    => '1',
                   "start"   => '2'
                );
  $state = array(
		"none"	           => "1",  
		"inProgress"	   => "2",  
		"success"            => "3",  
		"fail"		   => "4",  
		"invalidSource"      => "5",
		"invalidDestination" => "6",
		"outOfMemory"        => "7",
		"outOfSpace"         => "8",
		"fileNotFound"       => "9"
		);
  $filesrc  = ($objdevice->tftpparam["source"]=='tftp')
             ? ($objdevice->tftpparam["tftpip"].":".$objdevice->tftpparam["filesrc"])
             : "config.cfg";
  $filedst = ($objdevice->tftpparam["source"]=='tftp')
             ? "config.cfg"
             : ($objdevice->tftpparam["tftpip"].":".$objdevice->tftpparam["filedest"]);

  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG transfert: "."source's file=$filesrc, thedestination's file=$filedest"."\n");
  // set up the request
  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["filesource"], "type" => 's', "value" => "".$filesrc)
 		// set the filename being written
 		,array("oid" => $oid["filedest"], "type" => 's', "value" => $filedst)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $action["start"])
		);
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;
  if ($snmpok) {
    //set default status as "running"
    $result = $state["inProgress"];
    $snmpok= true;
    $j = 0;
    // check for the results status
    while ($snmpok && (($result == $state["inProgress"]) && ($j <20))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["action"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  $result = $ret_val;
                   sleep(3);
		  $j++; // not wait more than 60 seconds 
    }
    if ($result!=$state["success"]) {
       $ret_val= $error = "Error: SNMP Session failed during Transfert. ";
       foreach ($state as $ndx => $val) {
       	  if ($ndx == $result) {
       	    $ret_val.= $val;
       	    $error  .= $val;
       	  }
       }
       $snmpok = 0;
    }
  } else {
    $ret_val= $error = "Error: SNMP Session failed during setting commands. ";
    $snmpok = 0;
  }
}

function nortelTFTPNorteltransfert($objdevice,&$error,&$ret_val,&$snmpok) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok=0;
 $error ="";
 $ret_val="";
 $result ="";
  $oidbin = array(
		"tftphost" => ".1.3.6.1.4.1.45.1.6.4.2.2.1.5.1" //s5AgMyIfLdSvrAddr
		,"file" => ".1.3.6.1.4.1.45.1.6.4.2.2.1.4.1" //s5AgMyIfCfgFname
		,"action"	  => ".1.3.6.1.4.1.45.1.6.4.2.1.24.0" //s5AgInfoFileAction
		//s5AgSysAsciiConfigAutoDownload
		,"result"    => ".1.3.6.1.4.1.45.1.6.4.2.1.25.0" //s5AgInfoFileStatus
             );
  $oidascii = array(
		"tftphost" => ".1.3.6.1.4.1.45.1.6.4.2.2.1.5.1" //s5AgMyIfLdSvrAddr
		,"file"    => ".1.3.6.1.4.1.45.1.6.4.4.6.0" //s5AgMyIfCfgFname
		,"action"  => ".1.3.6.1.4.1.45.1.6.4.4.19.0" //s5AgInfoFileAction
		//s5AgSysAsciiConfigAutoDownload
		,"result"    => ".1.3.6.1.4.1.45.1.6.4.4.9.0" //s5AgInfoFileStatus
             );
// s5AgSysAsciiConfigFilename 1.3.6.1.4.1.45.1.6.4.4.6  when the s5AgSysAsciiConfigDownloadStatus object is set to startDownload(4).  
// s5AgSysAsciiConfigAutoDownload 1.3.6.1.4.1.45.1.6.4.4.7  
// s5AgSysAsciiConfigAutoDldStatus 1.3.6.1.4.1.45.1.6.4.4.8 
// s5AgSysAsciiConfigManualDownload 1.3.6.1.4.1.45.1.6.4.4.9 
  $action = array( "none"           => '1'
                   ,"downloadConfig"=> '2'
                   ,"downloadsw"    => '3'
                   ,"uploadconfig"  => '4'
                   ,"uploadsw" => '5'
                 );
  $state = array(
		"none"	           => "1",  
		"inProgress"	   => "2",  
		"success"            => "3",  
		"fail"     => "4"
		);
  if ($objdevice->tftpparam["binary"]==1) {$oid=&$oidbin;} else {$oid=&$oidascii;}
  $filetftp  = ($objdevice->tftpparam["source"]=='tftp')
             ? $objdevice->tftpparam["filesrc"]
             : $objdevice->tftpparam["filedest"];
  $theaction = ($objdevice->tftpparam["source"]=='tftp')
             ? $action["downloadConfig"] : $action["uploadconfig"];

  if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG transfert: "."file=$filetftp"."\n");
  // set up the request
  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["tftphost"], "type" => 'a', "value" => "".$objdevice->tftpparam["tftpip"])
 		// set the filename being written
 		,array("oid" => $oid["file"], "type" => 's', "value" => $filetftp)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $theaction)
		);
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;
  if ($snmpok) {
    //set default status as "running"
    $result = $state["inProgress"];
    $snmpok= true;
    $j = 0;
    // check for the results status
    while ($snmpok && (($result == $state["inProgress"]) && ($j <20))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["action"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  $result = $ret_val;
                   sleep(3);
		  $j++; // not wait more than 60 seconds 
    }
    if ($result!=$state["success"]) {
       $ret_val= $error = "Error: SNMP Session failed during Transfert. ";
       foreach ($state as $ndx => $val) {
       	  if ($ndx == $result) {
       	    $ret_val.= $val;
       	    $error  .= $val;
       	  }
       }
       $snmpok = 0;
    }
  } else {
    $ret_val= $error = "Error: SNMP Session failed during setting commands. ";
    $snmpok = 0;
  }
}

function nortelTFTPAlteontransfert($objdevice,&$error,&$ret_val,&$snmpok) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok=0;
 $error ="";
 $ret_val="";
 $result ="";
  $oid = array(
		"tftpserver" => ".1.3.6.1.4.1.1872.2.1.2.1.18.0" //agTftpServer
		,"filename" => ".1.3.6.1.4.1.1872.2.1.2.1.19.0" // agTftpCfgFileName
		,"action"	  => ".1.3.6.1.4.1.1872.2.1.2.1.21.0" //
		,"tftpresult"    => ".1.3.6.1.4.1.1872.2.1.2.1.17.0" //agLastSetErrorReason
		,"applyconfig"    => ".1.3.6.1.4.1.1872.2.1.2.1.2.0" //agApplyConfiguration
		,"status"    => ".1.3.6.1.4.1.1872.2.1.2.1.22.0" //agTftpLastActionStatus
             );
  $action = array( "none"      => '1'
                   ,"img-get"  => '2' //Download switch image from a specified image file (agTftpImageFileName) on the TFTP server to the destinated storage (agTftpImage).
                   ,"cfg-get"  => '3' //Download switch configuration from a specified file (agTftpCfgFileName) on the TFTP server.
                   ,"cfg-put"  => '4' //Upload switch configuration to a specified file (agTftpCfgFileName) on the TFTP server.
                   ,"dump-put" => '5' //Download switch core dump to a specified file (agTftpDumpFileName) on the TFTP server.
                  );
  if ($objdevice->tftpparam["source"]=='start') {
   $error  = "Error: Copying configurations to and from startup-config is not possible on this platform.";
   $ret_val= $error;  	
  } else {
   $filetftp  = ($objdevice->tftpparam["source"]=='tftp')
             ? $objdevice->tftpparam["filesrc"]
             : $objdevice->tftpparam["filedest"];
   $theaction = ($objdevice->tftpparam["source"]=='tftp')
             ? $action["cfg-get"] : $action["cfg-put"];

   if (($networkclass_isdebug)|| ($networkclass_islog))
     networkclass_debug("DEBUG transfert: "." file=$filetftp"."\n");
   // set up the request
   $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["tftpserver"], "type" => 'a', "value" => "".$objdevice->tftpparam["tftpip"])
 		// set the filename being written
 		,array("oid" => $oid["filename"], "type" => 's', "value" => $filetftp)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $theaction)
		);
   $snmpok = $objdevice->set_list($to_do);
   $snmpok= $objdevice->retcode;
   if ($snmpok) {
/*
    //set default status as "running"
    $result = $state["inProgress"];
    $snmpok= true;
    $j = 0;
    // check for the results status
    while ($snmpok && (($result == $state["inProgress"]) && ($j <20))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["action"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  $result = $ret_val;
                   sleep(3);
		  $j++; // not wait more than 60 seconds 
    }
    if ($result!=$state["success"]) {
       $ret_val= $error = "Error: SNMP Session failed during Transfert. ";
       foreach ($state as $ndx => $val) {
       	  if ($ndx == $result) {
       	    $ret_val.= $val;
       	    $error  .= $val;
       	  }
       }
       $snmpok = 0;
    }
*/
   } else {
    $ret_val= $error = "Error: SNMP Session failed during setting commands. ";
    $snmpok = 0;
   }
  }
}

function nortelTFTPrapidcitytransfert($objdevice,&$error,&$ret_val,&$snmpok) {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok=0;
 $error ="";
 $ret_val="";
 $result ="";
  $oidnotchassis = array(
		"rcTftpHost" => ".1.3.6.1.4.1.2272.1.2.1.0"
		,"rcTftpFile" => ".1.3.6.1.4.1.2272.1.2.2.0"
		,"action"	  => ".1.3.6.1.4.1.2272.1.2.3.0" //rcTftpAction
		,"rcTftpResult"    => ".1.3.6.1.4.1.2272.1.2.3.0"
             );
  $oidchassis = array(
		"rcTftpHost" => ".1.3.6.1.4.1.2272.1.100.7.2.0" // 	rc2kCopyFileDestination
		,"rcTftpFile" => ".1.3.6.1.4.1.2272.1.100.7.1.0"  // rc2kCopyFileSource
		,"action"	  => ".1.3.6.1.4.1.2272.1.100.7.3.0" //rcTftpAction
		,"rcTftpResult"    => "1.3.6.1.4.1.2272.1.100.7.4.0"
             );
  $action = array( "none"               => '1',
                   "downloadConfig"     => '2',
                   "uploadConfig"       => '3', 
                   "downloadSwToFlash"  => '4', 
                   "downloadSwToPcmcia" => '5', 
                   "uploadSw"           => '6', 
                   "downloadSwToDram"   => '7'
                  );
  $state = array(
		"none"	           => "1",  
		"inProgress"	   => "2",  
		"success"            => "3",  
		"fileAccessError"     => "4",
		"badFlash"     => "5", 
		"flashEraseFailed"     => "6",
		"pcmciaEraseFailed"     => "7",
		"success"     => "8",
		"fail"     => "9",
		"writeToNvramFailed"     => "10",
		"flashWriteFailed"     => "11",
		"pcmciaWriteFailed"     => "12",
		"configFileTooBig"     => "13",
		"imageFileTooBig"     => "14",
		"noPcmciaDetect"     => "15",
		"pcmciaNotSupported"     => "16",
		"invalidFile"     => "17",
		"noMemory"     => "18",
		"xferError"     => "19",
		"crcError"     => "20",
		"readNvramFailed"     => "21",
		"pcmciaWriteProtect"     => "22"
		);
   $RapidcityChassis=0;
   $description  = $objdevice->description;
   $oiddevice  = $objdevice->oiddevice;
   // check if it is a chassis (Passport)
   $RapidcityChassis= (substr_count($oiddevice,"1.3.6.1.4.1.2272.1.100")>0) ? 1 :0;
  if ($RapidcityChassis==1) {
  	// Chassis like Passports 8100 and 8600
  	if ($objdevice->tftpparam["source"]=='tftp') {
          // upload
           $param1= $objdevice->tftpparam["tftpip"].":".$objdevice->tftpparam["filesrc"];
  	   $param2= ($objdevice->tftpparam["startup"]==1) ? "boot.cfg" :"config.cfg";
        } else {
  	  // download
  	   $param1= ($objdevice->tftpparam["startup"]==1) ? "boot.cfg" :"config.cfg";
           $param2= $objdevice->tftpparam["tftpip"].":".$objdevice->tftpparam["filedest"];
        }
  	$theaction = 2;
  }
  else {
  	// not a chassis
  	$param1=$objdevice->tftpparam["tftpip"];
        $param2  = ($objdevice->tftpparam["source"]=='tftp')
             ? $objdevice->tftpparam["filesrc"]
             : $objdevice->tftpparam["filedest"];
  	$theaction = ($objdevice->tftpparam["source"]=='tftp')
             ? $action["downloadConfig"] : $action["uploadConfig"];
  }
  if (($networkclass_isdebug)|| ($networkclass_islog)) {
     if ($RapidcityChassis==1) { networkclass_debug("DEBUG transfert: "." Source=$param1 Destination=$param2"."\n");}
     else { networkclass_debug("DEBUG transfert: "." file=$param2"."\n");}
  }
  // set up the request
  if ($RapidcityChassis==1) {
  	  $oid = &$oidchassis;
	  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["rcTftpHost"], "type" => 's', "value" => "".$param1)
 		// set the filename being written
 		,array("oid" => $oid["rcTftpFile"], "type" => 's', "value" => $param2)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $theaction)
		);
  } else {
  	  $oid = &$oidnotchassis;
	  $to_do = array (
 		// set tftpserver ip address
 		array("oid" => $oid["rcTftpHost"], "type" => 'a', "value" => "".$param1)
 		// set the filename being written
 		,array("oid" => $oid["rcTftpFile"], "type" => 's', "value" => $param2)
 		// 
 		,array("oid" => $oid["action"], "type" => 'i', "value" => $theaction)
		);
  }
  $snmpok = $objdevice->set_list($to_do);
  $snmpok= $objdevice->retcode;
  if ($snmpok) {
    //set default status as "running"
    $result = $state["inProgress"];
    $snmpok= true;
    $j = 0;
    // check for the results status
    while ($snmpok && (($result == $state["inProgress"]) && ($j <20))) {
		  // get the current status of the tftp server's action
		  $objdevice->get($oid["action"]);
		  $snmpok= $objdevice->retcode;
		  $ret_val = $objdevice->result;
		  $result = $ret_val;
                   sleep(3);
		  $j++; // not wait more than 60 seconds 
    }
    if ($result!=$state["success"]) {
       $ret_val= $error = "Error: SNMP Session failed during Transfert. ";
       foreach ($state as $ndx => $val) {
       	  if ($ndx == $result) {
       	    $ret_val.= $val;
       	    $error  .= $val;
       	  }
       }
       $snmpok = 0;
    }
  } else {
    $ret_val= $error = "Error: SNMP Session failed during setting commands. ";
    $snmpok = 0;
  }
}

function nortelTFTPtransfert($objdevice) {
 global $networkclass_isdebug,$networkclass_islog;
 $error ="";
 $ret_val="";
 $snmpok=0;
 $typ = nortelChecktypdevice($objdevice);
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG TFTP transfert nortel $typ\n");
 if (substr_count($typ,"nortel")>0)        {nortelTFTPNorteltransfert($objdevice,$error,$ret_val,$snmpok);}
 elseif (substr_count($typ,"alteon")>0)    {nortelTFTPAlteontransfert($objdevice,$error,$ret_val,$snmpok);}
 elseif (substr_count($typ,"accelar")>0)   {nortelTFTPPassporttransfert($objdevice,$error,$ret_val,$snmpok);}
 elseif (substr_count($typ,"rapidcity")>0) {nortelTFTPrapidcitytransfert($objdevice,$error,$ret_val,$snmpok);}
 else {
   $ret_val= "unknow device";
   $snmpok = 0;
 }
 if (($networkclass_isdebug)|| ($networkclass_islog)) networkclass_debug("DEBUG TFTP nortel $typ transfert result: "."result=$ret_val".(($snmpok)?"":", error=".$error)."\n");
 $objdevice->result  = $ret_val;
 $objdevice->errormsg  = $error;
 $objdevice->retcode = $snmpok;
}

/* ************************************************************************
 TrapEvent : should return if the router has been changed in analysing the message of the syslog
 $result["changed"] = "running" "startup" or ""
 $result["host"] = host that has been changed;
 $result["date"] = 
           
 .....
!!!!!!!!!!!!! UNDER CONSTRUCTION !!!!!!!!!!!!!!!!!!!!!!!
*/
function nortelTrapEvent($objdevice,$syslogmsg="") {
 global $networkclass_isdebug,$networkclass_islog;
//force debug $objdevice->setdebug(true,true);
 $snmpok = 1; // default always OK but no trap
 $result = array("changed" => ""
                ,"host" => ""
                ,"date" => ""
                );
 $msg    = "Error: no trap configuration events";

 $objdevice->result= $result;
 $objdevice->errormsg = $msg;
 $objdevice->retcode = $snmpok;
 return $snmpok;
}

?>